// =====================================================================================================================
//  fennec, a free and open source game engine
//  Copyright © 2025 - 2026  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

#include <fennec/scene/scene.h>
#include <fennec/scene/scene_node.h>

namespace fennec
{

scene_node* scene::operator[](const cstring& name) const {
	list<size_t> parse;
	parse.push_back(tree_t::root);
	while (not parse.is_empty()) {
		const size_t n = parse.front();
		if (_tree[n]->name == name) {
			return _tree[n].get();
		}

		// Pre-Order traversal
		parse.push_front(_tree.next(n));
		parse.push_front(_tree.child(n));
		parse.pop_front();
	}
	return nullptr;
}

scene_node* scene::operator[](const string& name) const {
	list<size_t> parse;
	parse.push_back(tree_t::root);
	while (not parse.is_empty()) {
		const size_t n = parse.front();
		if (_tree[n]->name == name) {
			return _tree[n].get();
		}

		// Pre-Order traversal
		parse.push_front(_tree.next(n));
		parse.push_front(_tree.child(n));
		parse.pop_front();
	}
	return nullptr;
}

}
